package recursion;

/**
 *
 * @author Lefteris Moussiades
 */
public class IntroToRecursion {

    static void endless(int i) {
        System.out.println(i);
        endless(i + 1);
    }

    static void prt(int i) { //9  10  10   9
        System.out.println(i);
        if (i < 10) {
            prt(i + 1);
        }
        System.out.println(i);
    }

    static int power(int b, int e) { //e>=0
        int rVal = 1;
        for (int i = 1; i <= e; i++) {
            rVal = rVal * b;
        }
        return rVal;
    }

    static int powerR(int b, int e) { //e>=0 
        if (e == 0) {
            return 1;
        } else {
            return powerR(b, e - 1) * b; //2^3=2^2*2=4*2=8
        }                                //2^2=2^1*2=2*2=4   
    }                                   //2^1=2^0*2=2
                                        //2^0=1    
    
    static int fibonacci(int k) { //1,1,2,3,5,8
        if (k == 1 || k == 2) {
            return 1;
        } else {
            return fibonacci(k - 1) + fibonacci(k - 2);
        }
    }

    int factorialR(int n) { //n!=(1*2*3...*n-1*)*n
        if (n == 0 || n == 1) {
            return 1;
        } else {
            return factorialR(n - 1) * n;
        }
    }

    public static void main(String[] args) {
        //endless(5);
        //prt(8);
        
        int k=powerR(2,3);
        System.out.println(k);

    }

}
