package recursion;

/**
 *
 * @author Lefteris Moussiades
 */
public class TowersOfAnoi {

    private static void moveOne(int diskNo, char from, char to) {
        System.out.println("move disk " + diskNo
                + " from " + from + " to " + to);
    }

    public static void moveDisks(int n, char s, char d, char a) {
        if (n == 1) {
            moveOne(n, s, d);
        } else {
            moveDisks(n - 1, s, a, d);
            moveOne(n, s, d);
            moveDisks(n - 1, a, d, s);
        }
    }
    
    public static void main(String[] args) {
        moveDisks(3,'S','D','A');
    }

}
